#!/usr/bin/expect -f
#
# This Expect script was generated by autoexpect on Tue Mar 18 15:38:55 2003
# Expect and autoexpect were both written by Don Libes, NIST.
#
# Note that autoexpect does not guarantee a working script.  It
# necessarily has to guess about certain things.  Two reasons a script
# might fail are:
#
# 1) timing - A surprising number of programs (rn, ksh, zsh, telnet,
# etc.) and devices discard or ignore keystrokes that arrive "too
# quickly" after prompts.  If you find your new script hanging up at
# one spot, try adding a short sleep just before the previous send.
# Setting "force_conservative" to 1 (see below) makes Expect do this
# automatically - pausing briefly before sending each character.  This
# pacifies every program I know of.  The -c flag makes the script do
# this in the first place.  The -C flag allows you to define a
# character to toggle this mode off and on.

set force_conservative 0  ;# set to 1 to force conservative mode even if
			  ;# script wasn't run conservatively originally
if {$force_conservative} {
	set send_slow {1 .1}
	proc send {ignore arg} {
		sleep .1
		exp_send -s -- $arg
	}
}

#
# 2) differing output - Some programs produce different output each time
# they run.  The "date" command is an obvious example.  Another is
# ftp, if it produces throughput statistics at the end of a file
# transfer.  If this causes a problem, delete these patterns or replace
# them with wildcards.  An alternative is to use the -p flag (for
# "prompt") which makes Expect only look for the last line of output
# (i.e., the prompt).  The -P flag allows you to define a character to
# toggle this mode off and on.
#
# Read the man page for more info.
#
# -Don

# The following are 3 messages that ssh-keygen produces
# when you are generating a key:
#"Enter file in which to save the key (*.ssh/id_dsa): "
#"Enter passphrase (empty for no passphrase): "
#"Enter same passphrase again: "

# Check for id_dsa.pub - create if doesn't exist:
# Will also create ~/.ssh/ if necessary
if { ! [file exists ~/.ssh/id_dsa.pub] } { 
	spawn ssh-keygen -t dsa
	match_max 100000
	expect {
": $" {
	send "\r"
	exp_continue
} eof
}
}




# Make sure an argument was passed to us
if { "x$argv" == "x" } {
send_user "\nPlease specify command to run.\nYou may also specify multiple commands and pipes to run.\nSemicolons and Pipes must be escaped with the backslash\ncharacter so that your shell doesn't interpret them.\r\n\n"
exit 1 }
set IP_ADDR [lindex $argv 0]

catch {set DO_TASK "[lrange $argv 1 $argc]"}

# So here we get this silly brackets that set off any semicolon.
# These next 2 regsubs remove off any of these unneeded brackets.
regsub -all {\{} $DO_TASK {} DO_TASK
regsub -all {\}} $DO_TASK {} DO_TASK
if { "x$DO_TASK" == "x" } {
send_user "\nSorry, DO_TASK died.\r\n"
exit 1 }

set BASH_PROMPT "*\]\$ $"
#set SSH_PROMPT "*\]# $"
set SSH_PROMPT "*# $"
set HOMEDIR "~"
set SSHDIR "$HOMEDIR/.ssh"
set PASSWORD "password"
# Load ID_DSA_PUB with contents of ~/.ssh/id_dsa.pub
catch {open ~/.ssh/id_dsa.pub} fp
set line 0
gets $fp ID_DSA_PUB
close $fp

#
#[riblack@latr phase1-testing]$ ssh root@172.48.1.252
#The authenticity of host '172.48.1.252 (172.48.1.252)' can't be established.
#RSA key fingerprint is f6:c4:c0:f5:ae:3f:8b:c0:12:64:03:1a:be:a1:15:d9.
#Are you sure you want to continue connecting (yes/no)?
#
#
#[riblack@latr phase1-testing]$ ssh root@172.48.1.252
#The authenticity of host '172.48.1.252 (172.48.1.252)' can't be established.
#RSA key fingerprint is f6:c4:c0:f5:ae:3f:8b:c0:12:64:03:1a:be:a1:15:d9.
#Are you sure you want to continue connecting (yes/no)? yes
#Warning: Permanently added '172.48.1.252' (RSA) to the list of known hosts.
#root@172.48.1.252's password:
#
#
#[riblack@latr phase1-testing]$ ssh root@172.48.1.252
#root@172.48.1.252's password:
#Last login: Wed Oct  8 16:05:58 2003 from 172.48.0.1
#[root@localhost root]#
#


set timeout -1
spawn $env(SHELL)
match_max 100000
expect {


"$BASH_PROMPT" {
send -- "ssh root@$IP_ADDR\r"
exp_continue


} "Are you sure you want to continue connecting (yes/no)? " {
send -- "yes\r"
exp_continue


} "password: " {
send -- "$PASSWORD\r"
expect "$SSH_PROMPT"
send "DSA_KEY=\"$ID_DSA_PUB\"
grep \"\$DSA_KEY\" ~/.ssh/authorized_keys2 >/dev/null 2>&1 || 
{
echo -e \"\\n\\nInserting server DSA key into ~/.ssh/authorized_keys2\\n\\n\"
mkdir -p ~/.ssh
echo \"\$DSA_KEY\" >> ~/.ssh/authorized_keys2
}

\r"
expect "$SSH_PROMPT"
send -- ""
exp_continue


} "Host key verification failed." {
send -- "cat ~/.ssh/known_hosts | grep -v $IP_ADDR > ~/.ssh/known_hosts1; mv ~/.ssh/known_hosts1 ~/.ssh/known_hosts; ssh root@$IP_ADDR\r"
exp_continue


} "$SSH_PROMPT" {
#Hard coding ssh_mode to "NON-INTERACTIVE"
set SSH_MODE "INTERACTIVE"
set SSH_MODE "NON-INTERACTIVE"

if {$SSH_MODE=="INTERACTIVE"} {
send -- "$DO_TASK\r"
expect "$SSH_PROMPT"
send -- ""
expect "logout\r
*Connection to $IP_ADDR closed.\r\r
$BASH_PROMPT"
send -- ""
expect eof
#Do not exp_continue, just fall out and end
}
if {$SSH_MODE=="NON-INTERACTIVE"} {
send -- ""
expect "logout\r
*Connection to $IP_ADDR closed.\r\r
$BASH_PROMPT"
#Non-interactive ssh
send -- "ssh root@$IP_ADDR \"$DO_TASK\"\r"
expect "$BASH_PROMPT"
send -- ""
expect eof
#Do not exp_continue, just fall out and end
}


#End of "$SSH_PROMPT" expect entry
}
}
